<?php

//www.htmljie.com
if (!class_exists("WideoLisence")) {
	require WIDEO_PATH . "/class.lisence.php";
}
class Wideo
{
	protected $options;
	private $wideoLisence;
	protected $default = array("pcwidth" => "100%", "pcheight" => "396px", "mwidth" => "100%", "mheight" => "250px", "logo" => "true", "logourl" => WIDEO_URL . "/assets/images/mini-logo.png", "theme" => "#b7daff", "volume" => "0.7", "lang" => "zh-cn", "live" => "false", "autoplay" => "false", "loop" => "false", "screenshot" => "false", "hotkey" => "true", "preload" => "auto", "mutex" => "true", "danmaku" => "true", "danmakuapi" => "https://dplayer.alone88.cn/", "onlinevideo" => "true", "parse" => "false", "parseurl" => "https://jx.youyitv.com/?url=", "sitename" => "熊猫领地", "siteurl" => "https://www.wibir.cn/");
	public function __construct()
	{
		$this->options = get_option("wideo_setting");
		$this->wideoLisence = new WideoLisence();
		add_action("admin_menu", array($this, "wideo_admin_menu"));
		add_action("admin_init", array($this, "wideo_setting_init"));
		add_action("wp_enqueue_scripts", array($this, "wideo_scripts"));
		add_filter("plugin_action_links", array($this, "wideo_plugin_action_link"), 10, 4);
		add_action("admin_print_scripts", array($this, "wideo_quicktags"));
		add_action("init", array($this, "wideo_add_buttons"));
	}
	public function wideo_admin_menu()
	{
		add_menu_page("WIDEO 播放器", "WIDEO 播放器", "manage_options", "wideo", array($this, "wideo_admin_setting"), "dashicons-video-alt3");
		add_submenu_page("wideo", "关于", "关于", "manage_options", "wideo-about", array($this, "wideo_about"));
	}
	public function wideo_admin_setting()
	{
		@(require_once "includes/wideo_setting.php");
	}
	public function wideo_about()
	{
		@(require_once "includes/wideo_about.php");
	}
	public function wideo_setting_init()
	{
		register_setting("wideo_options_group", "wideo_setting", array($this, "validate"));
	}
	public function validate($input)
	{
		$valid = array();
		$valid["pcwidth"] = sanitize_text_field($input["pcwidth"]);
		$valid["pcheight"] = sanitize_text_field($input["pcheight"]);
		$valid["mwidth"] = sanitize_text_field($input["mwidth"]);
		$valid["mheight"] = sanitize_text_field($input["mheight"]);
		$valid["logo"] = sanitize_text_field($input["logo"]);
		$valid["logourl"] = sanitize_text_field($input["logourl"]);
		$valid["theme"] = sanitize_text_field($input["theme"]);
		$valid["volume"] = sanitize_text_field($input["volume"]);
		$valid["lang"] = sanitize_text_field($input["lang"]);
		$valid["live"] = sanitize_text_field($input["live"]);
		$valid["autoplay"] = sanitize_text_field($input["autoplay"]);
		$valid["loop"] = sanitize_text_field($input["loop"]);
		$valid["screenshot"] = sanitize_text_field($input["screenshot"]);
		$valid["hotkey"] = sanitize_text_field($input["hotkey"]);
		$valid["preload"] = sanitize_text_field($input["preload"]);
		$valid["mutex"] = sanitize_text_field($input["mutex"]);
		$valid["danmaku"] = sanitize_text_field($input["danmaku"]);
		$valid["danmakuapi"] = sanitize_text_field($input["danmakuapi"]);
		$valid["onlinevideo"] = sanitize_text_field($input["onlinevideo"]);
		$valid["parse"] = sanitize_text_field($input["parse"]);
		$valid["parseurl"] = sanitize_text_field($input["parseurl"]);
		$valid["sitename"] = sanitize_text_field($input["sitename"]);
		$valid["siteurl"] = sanitize_text_field($input["siteurl"]);
		if (strlen($valid["pcwidth"]) == 0) {
			$valid["pcwidth"] = $this->options["pcwidth"];
		}
		if (strlen($valid["pcheight"]) == 0) {
			$valid["pcheight"] = $this->options["pcheight"];
		}
		if (strlen($valid["mwidth"]) == 0) {
			$valid["mwidth"] = $this->options["mwidth"];
		}
		if (strlen($valid["mheight"]) == 0) {
			$valid["mheight"] = $this->options["mheight"];
		}
		if (strlen($valid["logo"]) == 0) {
			$valid["logo"] = $this->options["logo"];
		}
		if (strlen($valid["logourl"]) == 0) {
			$valid["logourl"] = $this->options["logourl"];
		}
		if (strlen($valid["theme"]) == 0) {
			$valid["theme"] = $this->options["theme"];
		}
		if (strlen($valid["volume"]) == 0) {
			$valid["volume"] = $this->options["volume"];
		}
		if (strlen($valid["lang"]) == 0) {
			$valid["lang"] = $this->options["lang"];
		}
		if (strlen($valid["live"]) == 0) {
			$valid["live"] = $this->options["live"];
		}
		if (strlen($valid["autoplay"]) == 0) {
			$valid["autoplay"] = $this->options["autoplay"];
		}
		if (strlen($valid["loop"]) == 0) {
			$valid["loop"] = $this->options["loop"];
		}
		if (strlen($valid["screenshot"]) == 0) {
			$valid["screenshot"] = $this->options["screenshot"];
		}
		if (strlen($valid["hotkey"]) == 0) {
			$valid["hotkey"] = $this->options["hotkey"];
		}
		if (strlen($valid["preload"]) == 0) {
			$valid["preload"] = $this->options["preload"];
		}
		if (strlen($valid["mutex"]) == 0) {
			$valid["mutex"] = $this->options["mutex"];
		}
		if (strlen($valid["danmaku"]) == 0) {
			$valid["danmaku"] = $this->options["danmaku"];
		}
		if (strlen($valid["danmakuapi"]) == 0) {
			$valid["danmakuapi"] = $this->options["danmakuapi"];
		}
		if (strlen($valid["onlinevideo"]) == 0) {
			$valid["onlinevideo"] = $this->options["onlinevideo"];
		}
		if (strlen($valid["parse"]) == 0) {
			$valid["parse"] = $this->options["parse"];
		}
		if (strlen($valid["parseurl"]) == 0) {
			$valid["parseurl"] = $this->options["parseurl"];
		}
		if (strlen($valid["sitename"]) == 0) {
			$valid["sitename"] = $this->options["sitename"];
		}
		if (strlen($valid["siteurl"]) == 0) {
			$valid["siteurl"] = $this->options["siteurl"];
		}
		return $valid;
	}
	public function wideo_scripts()
	{
		global $post, $posts;
		foreach ($posts as $post) {
			if (has_shortcode($post->post_content, "wideo")) {
				wp_enqueue_style("dp", WIDEO_URL . "/DPlayer/DPlayer.min.css", WIDEO_URL, false, $media = "all");
				wp_enqueue_script("dp_flv", WIDEO_URL . "/DPlayer/flv.min.js", WIDEO_URL, WIDEO_VERSION, false);
				wp_enqueue_script("dp_hls", WIDEO_URL . "/DPlayer/hls.min.js", WIDEO_URL, WIDEO_VERSION, false);
				wp_enqueue_script("dp", WIDEO_URL . "/DPlayer/DPlayer.min.js", WIDEO_URL, WIDEO_VERSION, false);
				wp_enqueue_style("responsive", WIDEO_URL . "/assets/css/responsive.css", WIDEO_URL, false, $media = "all");
				wp_enqueue_style("wideo", WIDEO_URL . "/assets/css/wideo.css", WIDEO_URL, false, $media = "all");
				add_action("wp_head", array($this, "wideo_custom_style"));
				break;
			}
		}
	}
	public function wideo_custom_style()
	{
		echo "<style type=\"text/css\">.wideolist .playlist li a:hover{background-color: " . $this->options["theme"] . ";}</style>";
	}
	public function wideo_plugin_action_link($actions, $plugin_file, $plugin_data)
	{
		if (strpos($plugin_file, "wideo") !== false && is_plugin_active($plugin_file)) {
			$_actions = array("option" => "<a href=\"" . WIDEO_ADMIN_URL . "admin.php?page=wideo\">设置</a>");
			$actions = array_merge($_actions, $actions);
		}
		return $actions;
	}
	public function wideo_quicktags()
	{
		wp_enqueue_script("wideo_quicktags", WIDEO_URL . "/assets/js/wideo_quicktags.js", array("quicktags"));
	}
	public function wideo_add_buttons()
	{
		if (!current_user_can("edit_posts") && !current_user_can("edit_pages")) {
			return;
		}
		if (get_user_option("rich_editing") == "true") {
			add_filter("mce_external_plugins", array($this, "add_wideo_tinymce_plugin"), 5);
			add_filter("mce_buttons", array($this, "register_wideo_button"), 5);
		}
	}
	public function add_wideo_tinymce_plugin($plugin_array)
	{
		$plugin_array["wideo"] = WIDEO_URL . "/assets/js/wideo_editor_plugin.js";
		return $plugin_array;
	}
	public function register_wideo_button($buttons)
	{
		array_push($buttons, "separator", "wideo");
		return $buttons;
	}
	public function activate()
	{
		if (!$this->options) {
			update_option("wideo_setting", $this->default);
		}
		setcookie("wideo-indate", time(), time() + 12 * 3600, "/");
		flush_rewrite_rules();
	}
	public function deactivate()
	{
		$this->wideoDelete();
		setcookie("wideo-indate", '', time() - 3600, "/");
		flush_rewrite_rules();
	}
	public function uninstall()
	{
		delete_option("wideo_setting");
		$this->wideoDelete();
		setcookie("wideo-indate", '', time() - 3600, "/");
		flush_rewrite_rules();
	}
	public function wideoDelete()
	{
		$cache = WIDEO_PATH . "DPlayer/dplayer.json";
		unlink($cache);
	}
}